@import "variables";

/* Elements */
html {
  font-size: 62.5%; // sets baseline for rem sizes
  -webkit-font-smoothing: antialiased;
}

body {
  font-family: $font-primary, $font-secondary;
  color: $text-primary;
  background-color: white;
  font-size: 16px;
  line-height: 28px;
  font-weight: 300;
  letter-spacing: 0.01em;
}

a {
  color: $nvidia-green;
  font-weight: 500;
  cursor: pointer;
  text-decoration: none;
}

button {
  font-family: $font-primary;
  min-height: 40px;
  background: $nvidia-green;
  border-radius: 0;
  display: flex;
  align-items: center;
  font-weight: bold;
  text-align: center;
  text-transform: uppercase;
  letter-spacing: -0.1px;
  margin: 10px 0;
  font-size: 18px;
  color: white;
  cursor: pointer;
  border: 2px solid $nvidia-green;
  padding: 0 25px;

  &:hover {
    background: $nvidia-green-highlight;
    border: 2px solid $nvidia-green-highlight;
  }

  &[disabled] {
    background-color: $rolling-stone;
    border: none;
    opacity: 0.4;

    &:hover {
      cursor: not-allowed;
    }
  }
}

button.secondary-btn {
  background-color: $nvidia-gray;
  border: 2px solid $nvidia-gray;

  &:hover {
    background-color: $nvidia-dark-gray;
    border: 2px solid $nvidia-dark-gray;
  }
}

h1 {
  color: $text-secondary;
  font-family: $font-primary;
  font-size: 70px;
  line-height: 80px;
  font-weight: 300;
}

h2 {
  color: $text-secondary;
  font-family: $font-primary;
  font-size: 26px;
  line-height: 38px;
  font-weight: 400;
}

h3 {
  color: $text-secondary;
  font-family: $font-primary;
  font-size: 17px;
  line-height: 25px;
  font-weight: 600;
  text-transform: uppercase;
}

h4 {
  color: $text-secondary;
  font-family: $font-primary;
  font-size: 16px;
  line-height: 24px;
  font-weight: 600;
}

label {
  color: black;
  text-transform: uppercase;
  font-size: 1.3rem;
  font-weight: 500;
  letter-spacing: 1.25px;
  line-height: 2.4rem;
  margin-bottom: 0.5rem;
}

input {
  &[type="number"],
  &[type="text"],
  &[type="password"] {
    height: 50px;
    background: white;
    border: 1px solid $border-gray;
    box-shadow: 0 2px 10px 0 rgba(181, 189, 201, 0.4);
    border-radius: 0;
    font-family: $font-primary;
    font-size: 16px;
    font-weight: 300;
    letter-spacing: -0.1px;
    padding: 0 20px;
    outline: none !important;

    &:focus {
      border: 1px solid $nvidia-green;
    }
  }

  // Hide default checkbox
  &[type="checkbox"]:not(:checked),
  &[type="checkbox"]:checked {
    position: absolute;
    opacity: 0;
    height: 0;
    width: 0;
  }

  // Checkbox label
  &[type="checkbox"]:not(:checked) + label,
  &[type="checkbox"]:checked + label {
    position: relative;
    padding-left: 41px;
    cursor: pointer;
  }

  // Base checkbox
  &[type="checkbox"]:not(:checked) + label::before,
  &[type="checkbox"]:checked + label::before {
    content: '';
    position: absolute;
    left: 0;
    top: 0;
    width: 24px;
    height: 23px;
    border: 1px solid $border-gray;
    background: white;
    border-radius: 0;
    box-shadow: 0 2px 10px 0 rgba(175, 184, 197, 0.2);
  }

  // Base checkbox (checked)
  &[type="checkbox"]:checked + label::before {
    height: 24px;
    border: 1px solid $nvidia-green;
  }

  // Filled check
  &[type="checkbox"]:not(:checked) + label::after,
  &[type="checkbox"]:checked + label::after {
    content: '';
    position: absolute;
    top: 1px;
    left: 1px;
    width: 22px;
    height: 22px;
    transition: all 0.2s;
    background: $nvidia-green;
    border: 2px solid white;
    opacity: 1;
  }

  // Hide check when unchecked
  &[type="checkbox"]:not(:checked) + label::after {
    opacity: 0;
  }
}

p {
  font-family: $font-secondary;
}

table {
  box-shadow: 0 2px 10px 0 rgba(181, 189, 201, 0.4);
  border: 1px solid $border-gray;
  border-collapse: collapse;
  background: white;

  thead {
    text-align: left;

    th {
      font-size: 1.3rem;
      font-weight: 600;
      letter-spacing: 1px;
      text-transform: uppercase;
      color: $text-secondary;
      padding: 20px 0;
    }
  }

  tr {
    display: table;
    table-layout: fixed;
    width: calc(100% - 40px);
    margin: auto;
  }

  tbody {
    overflow-y: auto;
    height: inherit;
    font-size: 16px;
    letter-spacing: -0.1px;
    font-weight: 400;
    display: block;

    tr {
      border-bottom: 1px solid $border-gray;

      td {
        padding: 20px 0;
      }
    }

    tr:last-child {
      border-bottom: none;
    }
  }
}

textarea {
  background: white;
  border: 1px solid $border-gray;
  box-shadow: 0 2px 10px 0 rgba(181, 189, 201, 0.4);
  border-radius: 0;
  font-family: $font-primary;
  font-size: 16px;
  font-weight: 300;
  letter-spacing: -0.1px;
  padding: 0 5px;
  outline: none !important;

  &:focus {
    border: 1px solid $border-gray;
  }
}

/* Class helpers */
.button-centered {
  margin: auto;
}

.dropdown {
  border-style: solid;
  border-width: 1px;
  border-radius: 0;
  box-shadow: 0 2px 10px 0 rgba(181, 189, 201, 0.4);

  /* https://material.io/resources/icons/?icon=expand_more&style=baseline */
  background-image: url("data:image/svg+xml;utf8,<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24' fill='rgb(118, 185, 0, 1)' width='48px' height='48px'><path d='M0 0h24v24H0z' fill='none'/><path d='M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z'/></svg>");
  background-repeat: no-repeat;
  background-position: right 12px center;
  background-size: 24px;
  background-color: white;
  border-color: $border-gray;
  font-size: 16px;
  font-weight: 300;
  height: 50px;
  width: 100%;
  cursor: pointer;
  outline: none !important;

  &:hover {
    border-color: $nvidia-green;
  }
}

.dropdown.dropdown-open {
  border-color: $nvidia-green;
}

.dropdown-actions {
  float: right;
  padding: 0 20px;

  a {
    font-weight: bold;
  }
}

.dropdown-options {
  position: absolute;
  border-style: solid;
  border-width: 1px;
  border-radius: 0;
  background-color: white;
  border-color: $heather;
  font-size: 16px;
  font-weight: 300;
  cursor: pointer;
  outline: none !important;
  padding: 8px 0;
  width: inherit;
  box-shadow: 2px 2px 10px 2px rgba(181, 189, 201, 0.4);
}

.dropdown-option {
  padding: 8px 20px;
  line-height: 30px;
  word-break: break-word;

  &:hover {
    color: $nvidia-green;
  }
}

.dropdown-option.selected-option {
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

.c-tabs {
  display: flex;
  height: 100%;
  align-items: center;

  .c-tab {
    color: $nvidia-green;
    display: flex;
    align-items: center;
    padding: 0 10px;
    cursor: pointer;
    min-width: 20px;

    &::after {
      content: '';
      border-bottom: 2px solid transparent;
      transition: all 0.4s;
      bottom: -10px;
      position: absolute;
      width: 100%;
      left: 0;
    }

    &.active-tab {
      position: relative;
    }

    &.active-tab::after {
      content: '';
      border-bottom: 2px solid $nvidia-green-highlight;
      transition: all 0.4s;
      bottom: -10px;
      position: absolute;
      width: 100%;
      left: 0;
    }

    .c-tab-close-btn {
      font-size: 16px;
      color: $nvidia-green;
      margin-left: 5px;
      margin-top: 3px;
    }

    .c-tab-title {
      min-width: 20px;
      overflow-x: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }
  }

  .c-tabs-add-container {
    line-height: 16px;
    margin-left: 10px;
    margin-top: 3px;

    .c-tabs-add-btn {
      cursor: pointer;
      color: $nvidia-green;
    }
  }

  .dropdown-options {
    z-index: 30;
  }
}

.card {
  box-shadow: 0 4px 5px 0 rgba(0, 0, 0, 0.14), 0 1px 10px 0 rgba(0, 0, 0, 0.12), 0 2px 4px -1px rgba(0, 0, 0, 0.3);
  border: 1px solid $border-gray;
  top: 0;

  &:hover {
    box-shadow: 0 0 8px 0 rgba(0, 0, 0, 0.13), 0 14px 32px 5px rgba(0, 0, 0, 0.13);
  }

  .card-title {
    padding: 2rem 2rem 1rem 2rem;
    letter-spacing: 1.5px;
    font-size: 1.6rem;
    line-height: 3rem;
    font-weight: 600;
  }

  .card-content {
    padding: 0 2rem 2rem 2rem;
    letter-spacing: -0.1px;
    font-size: 16px;
  }

  .card-footer {
    font-size: 1.4rem;
    padding: 0 2rem 2rem 2rem;
  }
}

.chip {
  background-color: $border-gray;
  border-radius: 32px;
  padding: 4px 12px;
  font-size: 13px;
  color: $nvidia-green;
  font-weight: bold;
}

.color-red { /* Deprecated */
  color: $radical-red;
}

.cumulus-toast {
  min-width: 300px;
  max-width: 500px;
  max-height: 200px;
  border: 1px solid;
  border-color: $border-gray;
  background-color: white;
  box-shadow: 0 2px 10px 0 rgba(181, 189, 201, 0.4);

  .toast-header {
    padding: 10px;

    .toast-title {
      font-size: 16px;
      font-weight: 600;
      letter-spacing: 1px;
      text-transform: uppercase;
    }

    .toast-close-btn {
      font-size: 1.3rem;
      font-weight: 400;
      cursor: pointer;
    }
  }

  .toast-body {
    font-size: 16px;
    font-weight: 300;
    letter-spacing: 0.01em;
    padding: 10px;
  }
}

.cursor-pointer {
  cursor: pointer;
}

.form-group {
  margin-bottom: 32px;
}

.jade-link {
  color: $nvidia-green;
  font-weight: 500;
  cursor: pointer;
}

.label {
  display: inline;
  font-size: 13px;
  font-weight: 700;
  text-transform: uppercase;
}

.nvidia-green {
  color: $nvidia-green !important;
}

.red {
  color: $radical-red !important;
}

.rotate-90 {
  transform: rotate(90deg);
}

.tag {
  border: 1px solid transparent;
  border-color: $nvidia-green;
  border-radius: 8px;
  color: $nvidia-green;
  font-size: 12px;
  margin: 5px;
  text-transform: uppercase;
  line-height: 1.5;
  padding: 0 0.75em;
}

.text-centered {
  text-align: center;
}

.text-small {
  font-size: 12px;
}

.white {
  color: white;
}

/***********************
* Deprecated
***********************/

.tabs {
  justify-content: center;

  .tab {
    position: relative;
    padding: 5px 10px;
    cursor: pointer;
    font-size: 16px;
    font-weight: 400;
    line-height: 2.4rem;

    &:hover {
      color: $nvidia-green;
    }
  }

  .tab.is-active {
    color: $nvidia-green;
  }
}

.tabs .tab.is-active::after {
  content: "";
  background-color: $nvidia-green;
  display: inline-block;
  height: 2px;
  width: 25px;
  position: absolute;
  top: inherit;
  bottom: -5px;
  left: 11px;
}
